class PaymentSlip {

  constructor(barcode, usingReader=false){
    if (usingReader) {
      this.barcode = this.buildBarcode([...barcode]);
    } else {
      this.barcode = barcode;
    }

    this.valid = this.validateBarcode([...this.barcode]);

    if (this.valid) {
      this.amount = this.getAmount();
      this.dueDate = this.calculateDueDate();
    }
  }

  buildBarcode(line) {
    throw new Error("Please don't do that");
  }

  validateBarcode(line) {
    throw new Error("Please don't do that");
  }

  getAmount() {
    throw new Error("Please don't do that");
  }

  calculateDueDate() {
    throw new Error("Please don't do that");
  }
}

module.exports = PaymentSlip;
