const TaxBill= require('./src/TaxBill');
const BankBill = require('./src/BankBill');

function createPaymentSlip(code, usingReader=false) {
  if (usingReader && code.length != 44) {
    return { valid: false };
  }
  if (code[0] === '8') {
    return new TaxBill(code, usingReader);
  } else {
    return new BankBill(code, usingReader);
  }
}

module.exports = createPaymentSlip;
